您的位置:首页 > 其它

codeforces 670C Cinema

2016-05-13 14:10 169 查看


C. Cinema

time limit per test
2 seconds

memory limit per test
256 megabytes

input
standard input

output
standard output

Moscow is hosting a major international conference, which is attended by n scientists
from different countries. Each of the scientists knows exactly one language. For convenience, we enumerate all languages of the world with integers from 1 to 109.
In the evening after the conference, all n scientists
decided to go to the cinema. There are m movies in the cinema they came to. Each
of the movies is characterized by two distinct numbers — the index of audio language and the index of subtitles language. The scientist, who came to the movie, will be very
pleased if he knows the audio language of the movie, will be almost satisfied if he knows the language of subtitles and will be not
satisfied if he does not know neither one nor the other (note that the audio language and the subtitles language for each movie are always different).
Scientists decided to go together to the same movie. You have to help them choose the movie, such that the number of very pleased scientists is maximum possible. If there are several
such movies, select among them one that will maximize the number of almost satisfied scientists.

Input
The first line of the input contains a positive integer n (1 ≤ n ≤ 200 000) —
the number of scientists.
The second line contains n positive
integers a1, a2, ..., an (1 ≤ ai ≤ 109),
where ai is
the index of a language, which the i-th scientist knows.
The third line contains a positive integer m (1 ≤ m ≤ 200 000) —
the number of movies in the cinema.
The fourth line contains m positive
integers b1, b2, ..., bm (1 ≤ bj ≤ 109),
where bj is
the index of the audio language of the j-th movie.
The fifth line contains m positive
integers c1, c2, ..., cm (1 ≤ cj ≤ 109),
where cj is
the index of subtitles language of the j-th movie.
It is guaranteed that audio languages and subtitles language are different for each movie, that is bj ≠ cj.

Output
Print the single integer — the index of a movie to which scientists should go. After viewing this movie the number of very pleased scientists should be maximum possible. If in the
cinema there are several such movies, you need to choose among them one, after viewing which there will be the maximum possible number of almost satisfied scientists.
If there are several possible answers print any of them.

Examples

input
3
2 3 2
2
3 2
2 3


output
2


input
6
6 3 1 1 3 7
5
1 2 3 4 5
2 3 4 5 1


output
1


Note
In the first sample, scientists must go to the movie with the index 2,
as in such case the 1-th and the 3-rd
scientists will be very pleased and the 2-nd scientist will be almost satisfied.
In the second test case scientists can go either to the movie with the index 1 or
the index 3. After viewing any of these movies exactly twoscientists
will be very pleased and all the others will be not satisfied.
题意:就是说现在有n个科学家打算去看电影,然后知道每个人知道那种语言,接下来知道有m场电影,每个电影有主次字幕,首先一行给出的是主字幕,下面一行给出次字幕让你找到在 -- 确保在主字幕人数最多的情况下,可以去看电影的人数最多。
思路:排序二分查找,使用lower_bound()函数
AC代码:
#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <algorithm>

using namespace std;

struct point {
int first;
int second;
} cinema[200005];
int person[200005];
int sum[200005];
int sum1[200005];

int main() {
int n;
scanf("%d",&n);
for(int i = 0; i < n; i++) {
scanf("%d",&person[i]);
}
sort(person,person+n);
int tol = 0;
int tt = 1;
for(int i = 0; i < n; i++) {//把懂相同字幕的人计算在一起
if(person[i] == person[i+1]) {
tt++;
continue;
}
sum[tol] = person[i];
sum1[tol++] = tt;
tt = 1;
}
int m;
scanf("%d",&m);
for(int i = 0; i < m; i++) {
scanf("%d",&cinema[i].first);
}
int maxfist = 1;
int maxsc = 1;
int index = 0;
for(int i = 0; i < m; i++) {//枚举电影场次,
scanf("%d",&cinema[i].second);
int fist = 1;
int sc = 1;
int g = lower_bound(sum,sum+tol,cinema[i].first)-sum;//获取主字幕的人数
if(sum[g] == cinema[i].first) {
fist += sum1[g];
}
g = lower_bound(sum,sum+tol,cinema[i].second)-sum;//获取次字母的人数
if(sum[g] == cinema[i].second) {
sc += sum1[g];
}
if(maxfist < fist) {
maxfist = fist;
maxsc = sc;
index = i;
}
if(maxfist == fist) {
if(maxsc < sc) {
maxsc = sc;
index = i;
}
}
}
printf("%d\n",index+1);
return 0;
}
很简单的题目,但是自己第一次写的时候超时了,是自己没有用这种二分查找的思想,直接写的暴力,所以超时了,加油!!!!
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: